/* 
 * Copyleft 2004 Frank Hale
 * frankhale@gmail.com
 * http://frankhale.org
 *
 * This code is released under the GPL license www.gnu.org
 */
#ifndef _AEWM_HH_
#define _AEWM_HH_

#define WINDOW_MANAGER_NAME "aewm++"
#define VERSION "1.0.29"
#define RELEASE_DATE "7 January, 2005"

#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <stdlib.h>
#include <iostream>
#include <string>
#include <list>

#include <X11/cursorfont.h>
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xmd.h>
#ifdef SHAPE
#include <X11/extensions/shape.h>
#endif

using namespace std;

#define DEF_FONT	"Fixed"
#define DEF_FG		"#ffffff"
#define DEF_BG		"#646a8c"
#define DEF_FC		"#d1d1d1"
#define DEF_BD		"#000000"
#define DEF_NEW1	"" 
#define DEF_NEW2	"xterm -ls -sb -bg black -fg white"
#define DEF_BW		1
#define SPACE		3
#define MINSIZE		15
#define EDGE_SNAP	"true"
#define SNAP		5
#define TEXT_JUSTIFY	"center"
#define WIRE_MOVE	"true"
#define MAX_DESKTOPS	4
#define DEF_FM		"click"
#define DEF_WP          "mouse"

#define TRANSIENT_WINDOW_HEIGHT 8

// MOTIF hints
//#define MwmHintsFunctions     	(1l << 0)
#define MwmHintsDecorations   		(1l << 1)
//#define MwmFuncAll            	(1l << 0)
//#define MwmFuncResize         	(1l << 1)
//#define MwmFuncMove           	(1l << 2)
//#define MwmFuncIconify        	(1l << 3)
//#define MwmFuncMaximize       	(1l << 4)
//#define MwmFuncClose          	(1l << 5)
#define MwmDecorAll           		(1l << 0)
#define MwmDecorBorder        		(1l << 1)
//#define MwmDecorHandle        	(1l << 2)
#define MwmDecorTitle         		(1l << 3)
//#define MwmDecorMenu          	(1l << 4)
//#define MwmDecorIconify       	(1l << 5)
//#define MwmDecorMaximize      	(1l << 6)

#define PropMwmHintsElements 3

typedef struct MwmHints {
  unsigned long flags, functions, decorations;
} MwmHints;

// Extended Net Hints stuff 
struct NetWMStates
{
	bool modal;
	bool sticky;
	bool max_vert;
	bool max_horz;
	bool shaded;
	bool skip_taskbar;
	bool skip_pager; 
};

struct Strut
{
	// Size of strut per border
	CARD32 east;
	CARD32 west;
	CARD32 north;
	CARD32 south;
};

#define WIN_HINTS_DO_NOT_COVER  	(1<<5)
#define WIN_STATE_STICKY		(1<<0) 

#define NET_WM_STATE_MAX_STATES 	7
#define NET_WM_STICKY_WINDOW		0xffffffff
#define _NET_WM_STATE_REMOVE        	0    /* remove/unset property */
#define _NET_WM_STATE_ADD           	1    /* add/set property */
#define _NET_WM_STATE_TOGGLE        	2    /* toggle property  */

// Text Justify for window titlebars
enum { LEFT_JUSTIFY, CENTER_JUSTIFY, RIGHT_JUSTIFY };

// Shorthand for wordy function calls
#define setmouse(w, x, y) XWarpPointer(dpy, None, w, 0, 0, 0, 0, x, y)
#define Ungrab() XUngrabPointer(dpy, CurrentTime)
#define Grab(w, mask, curs) (XGrabPointer(dpy, w, False, mask, \
    GrabModeAsync, GrabModeAsync, None, curs, CurrentTime) == GrabSuccess)

// Border width accessor to handle hints/no hints
#define BW (has_border ? wm->getOptBW() : 0)

// Multipliers for calling gravitate 
#define APPLY_GRAVITY 1
#define REMOVE_GRAVITY -1

// Modes to call get_incsize with 
#define PIXELS 0
#define INCREMENTS 1

// defined in main.cc
void forkExec(char *);
int handleXError(Display *, XErrorEvent *);
#ifdef NEED_SETENV
int setenv(char *name, char *value, int clobber);
#endif

enum { FOCUS_FOLLOW, FOCUS_SLOPPY, FOCUS_CLICK };

class Client;

#include "basemenu.hh"
#include "genericmenu.hh"
#include "windowmenu.hh"
#include "iconmenu.hh"
#include "client.hh"
#include "windowmanager.hh"

#endif // _AEWM_HH_ 
